<template>
  <div class="informatives">
    <div class="columns">
      <div class="column is-2">
        <the-sidebar />
      </div> <!-- column -->
      <div class="column">
        <div class="box">
          <div class="level">
            <div class="level-left">
              <the-header title="Informativos" subtitle="Informativos cadastrados no sistema" />
            </div> <!-- level-left -->
            <div class="level-right">
              <router-link
                class="button is-primary"
                :to="{name: 'admin-create-informatives'}">Novo informativo
              </router-link>
            </div> <!-- level-right -->
          </div>
          <the-admin-table
            :key="adminTableKey"
            :isLoading="isLoading"
            title="Informativos adicionados"
            perPage="20"
            :content="informatives"
            :columns="columns"
            v-on:createItem="createItem"
            v-on:readItem="readItem"
            v-on:updateItem="updateItem"
            v-on:deleteItem="deleteItem">
          </the-admin-table>
        </div> <!-- box -->
      </div> <!-- column -->
    </div> <!-- columns -->
  </div>
</template>

<script>
export default {
  name: 'IndexInformatives',
  data: function ()  {
    return {
      adminTableKey: 0,
    }
  },
  created () {
    this.$store.dispatch('getInformatives')
  },
  methods: {
    forceRerender ()  {
      this.adminTableKey += 1
    },
    createItem: function () {
    },
    readItem: function (obj) {
      this.$router.push({ name: 'read-informatives', params: { pk: obj.id } })
    },
    updateItem: function (obj) {
      this.$router.push({ name: 'admin-update-informatives', params: { pk: obj.id } })
    },
    deleteItem: function (obj) {
      this.$store.dispatch('deleteInformative', obj)
      this.forceRerender()
    }
  },
  computed: {
    informatives () {
      return this.$store.state.informatives.informatives
    },
    columns () {
      return [
        {
          field: 'id',
          label: 'ID',
          numeric: true,
          sortable: true
        },
        {
          field: 'published_at',
          label: 'Publicado em',
          sortable: true
        },
        {
          field: 'title',
          label: 'Título',
          sortable: true
        },
        {
          field: 'link',
          label: 'Link de acesso',
        },
        {
          field: 'created_at',
          label: 'Criado em'
        },
        {
          field: 'updated_at',
          label: 'Atualizado em'
        }
      ]

    },
    isLoading () {
      return this.$store.state.informatives.loading
    },
    error () {
      return this.$store.state.informatives.error
    },
    errorMsg () {
      return this.$store.state.informatives.errorMsg
    }
  }
}
</script>
